/*
 *
 * Perforce/JBuilder Opentool
 * Copyright (C) 2001 David Freels
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package com.dafreels.opentools.actions;

//JBuilder
import com.borland.primetime.*;
import com.borland.primetime.actions.*;
import com.borland.primetime.node.*;
import com.borland.jbuilder.*;
import com.borland.primetime.ide.*;

//Java
import javax.swing.*;
import java.awt.event.*;
import java.awt.Cursor;

//JBuilder OT
import com.dafreels.opentools.*;
import com.dafreels.opentools.properties.*;
import com.dafreels.opentools.actions.ui.*;

//Perforce OT
import com.dafreels.vcs.command.*;
import com.dafreels.vcs.util.ExtensionRegistry;
import com.dafreels.vcs.util.ActionImages;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      DF Systems
 * @author David Freels
 * @version 1.0
 */

public class AddAction extends PerforceAction
{
	public AddAction(boolean onFileTabMenu)
	{
		super("Add","Add file(s) to source control",ActionImages.P4_ADD, onFileTabMenu);
	}

	public void actionPerformed(Browser browser)
	{
		//Get a list of the selected nodes
		com.dafreels.vcs.command.Command cmd =
			new com.dafreels.vcs.command.Command(com.dafreels.vcs.command.Command.ADD);
		Node[] nodes = getSelectedNodes(browser, cmd);

		AddFilesDialog dialog = new AddFilesDialog(browser, true);
		dialog.fillForm(cmd.getPaths());
		dialog.setVisible(true);
		if ( dialog.wasCanceled() )
		{
			return;
		}
		String changeList = dialog.getChangelist();
		if ( changeList != null )
		{
			com.dafreels.vcs.command.Command cmd2 =
				new com.dafreels.vcs.command.Command(com.dafreels.vcs.command.Command.ADD);
			cmd2.addPath("-c "+changeList);
			cmd2.addPaths(dialog.getFiles());
			cmd = cmd2;
		}
		/*StringBuffer sb = new StringBuffer("add ");
		Node[] nodes = null;
		String tempFileName = "";
		if ( m_onFileTabMenu )
		{
			Node node = browser.getActiveNode();
			if ( node != null )
			{
				tempFileName = node.getLongDisplayName();
				if(m_reg.validateFile(tempFileName))
				{
					cmd.addPath(tempFileName);
					nodes = new Node[1];
					nodes[0] = node;
				}
				else
				{
					return;
				}
			}
			else
			{
				return;
			}
		}
		else
		{

			nodes = browser.getProjectView().getSelectedNodes(browser.getActiveProject());


		//Send any files that have legal extensions to the command
			for(int i = 0; i < nodes.length; i++)
			{
				tempFileName = ((FileNode)nodes[i]).getLongDisplayName();
				if(m_reg.validateFile(tempFileName))
				{
					//sb.append(tempFileName+" ");
					cmd.addPath(tempFileName);
				}
			}

		}
		*/
		if ( cmd.getPathCount() == 0 )
		{
			return;
		}
		runCommand(browser, cmd);
		/*
		try
		{
			browser.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			CommandTool.runCommand(cmd, Main.m_props);
			//Run the command
			//CommandTool.runCommand(sb.toString(), Main.m_props);

			//Output the p4 messages
			MessageWriter.outputErrorMessages(MessageFormatter.getInstance());
			if ( Main.m_props.showOutput())
			{
				MessageWriter.outputMessages(MessageFormatter.getInstance());
			}
		}
		finally
		{
			browser.setCursor(Cursor.getDefaultCursor());
		}
		*/
		//Refresh the nodes
		if ( nodes != null )
		{
			Main.refreshNodes(nodes);
		}
	}
	public boolean runCommand(Browser browser, com.dafreels.vcs.command.Command cmd)
	{
		return super.runCommand(browser, cmd);
	}
}