/*
 *
 * Perforce/JBuilder Opentool
 * Copyright (C) 2002 Mark Ackerman
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package com.dafreels.opentools.actions;

//JBuilder
import com.borland.primetime.*;
import com.borland.primetime.actions.*;
import com.borland.primetime.node.*;
import com.borland.jbuilder.*;
import com.borland.primetime.ide.*;

//Java
import javax.swing.*;
import java.awt.event.*;

//JBuilder OT
import com.dafreels.opentools.*;
import com.dafreels.opentools.actions.ui.*;
import com.dafreels.opentools.properties.*;

//Perforce VCS
import com.dafreels.vcs.command.*;
import com.dafreels.vcs.util.ExtensionRegistry;
import com.dafreels.vcs.util.ActionImages;

/**
 * Title: Perforce Open Tool
 * Description: get the history for a file
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author Mark Ackerman
 * @version 1.0
 */

public class FileHistoryAction extends PerforceAction
{

	public FileHistoryAction(boolean onFileTabMenu)
	{
		super("Revision History",null, ActionImages.P4_HISTORY, onFileTabMenu);
	}

	public void actionPerformed(Browser browser)
	{
		com.dafreels.vcs.command.Command cmd =
			new com.dafreels.vcs.command.Command(com.dafreels.vcs.command.Command.FILEHISTORY);
		Node[] nodes = getSelectedNodes(browser, cmd);
		/*
		//Get a list of the selected nodes
		Node[] nodes = browser.getProjectView().getSelectedNodes(browser.getActiveProject());

		StringBuffer sb = new StringBuffer("filelog ");
		String tempFileName = "";

		for(int i = 0; i < nodes.length; i++)
		{
			tempFileName = ((FileNode)nodes[i]).getLongDisplayName();
			if(m_reg.validateFile(tempFileName))
			{
				sb.append(tempFileName+" ");
			}
		}

		//Run the command
		CommandTool.runCommand(sb.toString(), Main.m_props);
		*/
		CommandTool.runCommand(cmd, Main.m_props);
		if ( cmd.getPathCount() == 0 )
		{
			return;
		}
		HistoryDialog dialog = new HistoryDialog(Browser.getActiveBrowser(),
			"File Information", false);
		dialog.fillForm(((FileNode)nodes[0]).getLongDisplayName(),
			MessageFormatter.getInstance());
		dialog.setVisible(true);
		//Output the p4 messages
		//MessageWriter.outputMessages(MessageFormatter.getInstance());

		//Force JBuilder to check the file status
		if ( nodes != null )
		{
			Main.refreshNodes(nodes);
		}
	}
}
