/*
 *
 * Perforce/JBuilder Opentool
 * Copyright (C) 2002 Mark Ackerman
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package com.dafreels.opentools.actions;

//JBuilder
import com.borland.primetime.*;
import com.borland.primetime.actions.*;
import com.borland.primetime.node.*;
import com.borland.jbuilder.*;
import com.borland.primetime.ide.*;

//Java
import javax.swing.*;
import java.awt.event.*;

//JBuilder OT
import com.dafreels.opentools.*;
import com.dafreels.opentools.actions.ui.*;
import com.dafreels.opentools.properties.*;

//Perforce VCS
import com.dafreels.vcs.command.*;
import com.dafreels.vcs.util.ExtensionRegistry;
import com.dafreels.vcs.util.ActionImages;

/**
 * Title: Perforce Open Tool
 * Description: get the history for a file
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author Mark Ackerman
 * @version 1.0
 */

public class NotInDepotAction extends BrowserAction
{
	private NotInDepotDialog _dialog;

	public NotInDepotAction()
	{
		super("Not In Depot");
		setSmallIcon(ActionImages.P4_FILES_NOT_IN_DEPOT);
		setLongText("Display files that aren't in the depot");
	}
	public void actionPerformed(Browser browser)
	{
		if ( _dialog == null )
		{
			_dialog = new NotInDepotDialog(browser, false);
		}
		_dialog.setVisible(true);
	}
}
